--- ../bash-completion-20080705/bash_completion	2008-07-05 22:55:03.000000000 +0900
+++ bash_completion	2008-09-12 21:10:42.000000000 +0900
@@ -267,16 +267,22 @@
 
 	_expand || return 0
 
-	local toks=( ) tmp
+	local toks=( ) tmp suffix_opt=( )
+	if [[ "$1" = "-F" || "$2" = "-F" ]]; then
+	  suffix_opt=( -S '/' )
+	fi
 	while read -r tmp; do
 		[[ -n $tmp ]] && toks[${#toks[@]}]=$tmp
-	done < <( compgen -d -- "$(quote_readline "$cur")" )
+	done < <( compgen -d "${suffix_opt[@]}" -- "$(quote_readline "$cur")" )
 	
 	if [[ "$1" != -d ]]; then
+		if [[ "$2" = "-F" ]]; then
+			suffix_opt=( -S ' ' )
+		fi
 		xspec=${1:+"!*.$1"}
 		while read -r tmp; do
 			[[ -n $tmp ]] && toks[${#toks[@]}]=$tmp
-		done < <( compgen -f -X "$xspec" -- "$(quote_readline "$cur")" )
+		done < <( compgen -f "${suffix_opt[@]}" -X "$xspec" -- "$(quote_readline "$cur")" )
 	fi
 
 	COMPREPLY=( "${COMPREPLY[@]}" "${toks[@]}" )
@@ -3128,7 +3134,7 @@
 	# Use standard dir completion if no CDPATH or parameter starts with /,
 	# ./ or ../
 	if [ -z "${CDPATH:-}" ] || [[ "$cur" == ?(.)?(.)/* ]]; then
-		_filedir -d
+		_filedir -d -F
 		return 0
 	fi
 
@@ -3147,7 +3153,7 @@
 		done
 	done
 
-	_filedir -d
+	_filedir -d -F
 
 	if [[ ${#COMPREPLY[@]} -eq 1 ]]; then
 	    i=${COMPREPLY[0]}
@@ -3159,9 +3165,9 @@
 	return 0
 }
 if shopt -q cdable_vars; then
-    complete -v -F _cd $nospace $filenames cd
+    complete -v -F _cd $nospace cd
 else
-    complete -F _cd $nospace $filenames cd
+    complete -F _cd $nospace cd
 fi
 
 _remove_comp_word()
